/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: JavaTaskExecutableObjectStub.java,v 1.4 2005/02/16 22:20:15 qiyanli Exp $
 *
 * Contributors:
 * IBM Rational - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.execution.local;

import org.eclipse.hyades.execution.core.impl.IJavaTaskExecutableObject;
import org.eclipse.hyades.execution.invocation.RemoteInvocationException;
import org.eclipse.hyades.execution.invocation.ReturnData;

/**
 * Provide remote invocation semantics for <code>JavaTaskExecutableObject</code>s.
 */
public class JavaTaskExecutableObjectStub
	extends ExecutableObjectStub
	implements IJavaTaskExecutableObject {

	/**
	 * This operation is performed on the remote side.
	 * 
	 * @see org.eclipse.hyades.execution.core.impl.IJavaTaskExecutableObject#run()
	 */
	public void run() {
		ReturnData rtnData = delegateRemoteCall(
			new Class[]{},
			new Object[]{},
			"run");
		if ( rtnData.isError() )
			throw new RemoteInvocationException((Throwable)rtnData.getReturnValue());
	}

	/**
	 * @see org.eclipse.hyades.execution.core.impl.IJavaTaskExecutableObject#start()
	 */
	public void start() {
		ReturnData rtnData = delegateRemoteCall(
			new Class[]{},
			new Object[]{},
			"start");
		if ( rtnData.isError() )
			throw new RemoteInvocationException((Throwable)rtnData.getReturnValue());
	}

	/**
	 * @see org.eclipse.hyades.execution.core.impl.IJavaTaskExecutableObject#stop()
	 */
	public void stop() {
		ReturnData rtnData = delegateRemoteCall(
			new Class[]{},
			new Object[]{},
			"stop");
		if ( rtnData.isError() )
			throw new RemoteInvocationException((Throwable)rtnData.getReturnValue());
	}

}
