/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: FileConnectionHandlerImpl.java,v 1.6 2005/05/05 20:04:37 samwai Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.hyades.internal.collection.framework;

import java.net.Socket;

import org.eclipse.hyades.execution.security.IClientHandler;
import org.eclipse.hyades.execution.security.IConnectionHandler;
import org.eclipse.hyades.internal.execution.file.FileServiceConstants;
import org.eclipse.hyades.internal.execution.local.common.Constants;

/**
 * @author Giridhar.S
 *  
 */
public class FileConnectionHandlerImpl implements IConnectionHandler, Constants, FileServiceConstants {

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.hyades.execution.security.IConnectionHandler#connectionAccepted(java.net.Socket)
     */
    public void connectionAccepted(Socket s) {

        /*
         * Create a new clientHandler thread for each request that comes along,
         * and pass the socket to the client handler. The client handler thread
         * reads the information sent by the client, and performs the file
         * transfer.
         */

        IClientHandler clientHandler = new FileClientHandlerImpl(s);
        ((FileClientHandlerImpl) clientHandler).setDaemon(true);
        ((FileClientHandlerImpl) clientHandler).start();
    }
}