/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Component.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.context;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.util.FeatureMap;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * 				Describes a loadable component, by providing the
 * 				executable class name and descriptive information for
 * 				the purpose of compatability checking for the component.
 * 			
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getGroup <em>Group</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getComponent <em>Component</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getExecutableClass <em>Executable Class</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationCreationDate <em>Implementation Creation Date</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersion <em>Implementation Version</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersionDescription <em>Implementation Version Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getLoggingLevel <em>Logging Level</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole <em>Role</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleCreationDate <em>Role Creation Date</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersion <em>Role Version</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersionDescription <em>Role Version Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getUniqueID <em>Unique ID</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent()
 * @model 
 * @generated
 */
public interface Component extends EObject{
	/**
	 * Returns the value of the '<em><b>Group</b></em>' attribute list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Group</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Group</em>' attribute list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_Group()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry" many="true"
	 * @generated
	 */
	FeatureMap getGroup();

	/**
	 * Returns the value of the '<em><b>Component</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.logging.adapter.model.internal.context.Component}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component</em>' containment reference list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_Component()
	 * @model type="org.eclipse.hyades.logging.adapter.model.internal.context.Component" containment="true" resolveProxies="false" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	EList getComponent();

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_Description()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Executable Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Executable Class</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Executable Class</em>' attribute.
	 * @see #setExecutableClass(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_ExecutableClass()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getExecutableClass();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getExecutableClass <em>Executable Class</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Executable Class</em>' attribute.
	 * @see #getExecutableClass()
	 * @generated
	 */
	void setExecutableClass(String value);

	/**
	 * Returns the value of the '<em><b>Implementation Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Implementation Creation Date</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Implementation Creation Date</em>' attribute.
	 * @see #setImplementationCreationDate(Object)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_ImplementationCreationDate()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.DateTime"
	 * @generated
	 */
	Object getImplementationCreationDate();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationCreationDate <em>Implementation Creation Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Implementation Creation Date</em>' attribute.
	 * @see #getImplementationCreationDate()
	 * @generated
	 */
	void setImplementationCreationDate(Object value);

	/**
	 * Returns the value of the '<em><b>Implementation Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Implementation Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Implementation Version</em>' attribute.
	 * @see #setImplementationVersion(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_ImplementationVersion()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getImplementationVersion();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersion <em>Implementation Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Implementation Version</em>' attribute.
	 * @see #getImplementationVersion()
	 * @generated
	 */
	void setImplementationVersion(String value);

	/**
	 * Returns the value of the '<em><b>Implementation Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Implementation Version Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Implementation Version Description</em>' attribute.
	 * @see #setImplementationVersionDescription(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_ImplementationVersionDescription()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getImplementationVersionDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersionDescription <em>Implementation Version Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Implementation Version Description</em>' attribute.
	 * @see #getImplementationVersionDescription()
	 * @generated
	 */
	void setImplementationVersionDescription(String value);

	/**
	 * Returns the value of the '<em><b>Logging Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Logging Level</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Logging Level</em>' attribute.
	 * @see #setLoggingLevel(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_LoggingLevel()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getLoggingLevel();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getLoggingLevel <em>Logging Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Logging Level</em>' attribute.
	 * @see #getLoggingLevel()
	 * @generated
	 */
	void setLoggingLevel(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_Name()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Role</b></em>' attribute.
	 * The default value is <code>"sensor"</code>.
	 * The literals are from the enumeration {@link org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Role</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Role</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @see #isSetRole()
	 * @see #unsetRole()
	 * @see #setRole(RoleNames)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_Role()
	 * @model default="sensor" unique="false" unsettable="true" required="true"
	 * @generated
	 */
	RoleNames getRole();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole <em>Role</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Role</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @see #isSetRole()
	 * @see #unsetRole()
	 * @see #getRole()
	 * @generated
	 */
	void setRole(RoleNames value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole <em>Role</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetRole()
	 * @see #getRole()
	 * @see #setRole(RoleNames)
	 * @generated
	 */
	void unsetRole();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole <em>Role</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Role</em>' attribute is set.
	 * @see #unsetRole()
	 * @see #getRole()
	 * @see #setRole(RoleNames)
	 * @generated
	 */
	boolean isSetRole();

	/**
	 * Returns the value of the '<em><b>Role Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Role Creation Date</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Role Creation Date</em>' attribute.
	 * @see #setRoleCreationDate(Object)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_RoleCreationDate()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.DateTime"
	 * @generated
	 */
	Object getRoleCreationDate();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleCreationDate <em>Role Creation Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Role Creation Date</em>' attribute.
	 * @see #getRoleCreationDate()
	 * @generated
	 */
	void setRoleCreationDate(Object value);

	/**
	 * Returns the value of the '<em><b>Role Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Role Version</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Role Version</em>' attribute.
	 * @see #setRoleVersion(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_RoleVersion()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getRoleVersion();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersion <em>Role Version</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Role Version</em>' attribute.
	 * @see #getRoleVersion()
	 * @generated
	 */
	void setRoleVersion(String value);

	/**
	 * Returns the value of the '<em><b>Role Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Role Version Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Role Version Description</em>' attribute.
	 * @see #setRoleVersionDescription(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_RoleVersionDescription()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getRoleVersionDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersionDescription <em>Role Version Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Role Version Description</em>' attribute.
	 * @see #getRoleVersionDescription()
	 * @generated
	 */
	void setRoleVersionDescription(String value);

	/**
	 * Returns the value of the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unique ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unique ID</em>' attribute.
	 * @see #setUniqueID(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getComponent_UniqueID()
	 * @model unique="false" id="true" dataType="org.eclipse.emf.ecore.xml.type.ID" required="true"
	 * @generated
	 */
	String getUniqueID();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getUniqueID <em>Unique ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unique ID</em>' attribute.
	 * @see #getUniqueID()
	 * @generated
	 */
	void setUniqueID(String value);

} // Component
