/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: RoleNames.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.context;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Role Names</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 * 				describes possible components for the adapter. Not clear
 * 				if this is the correct list we need for R1
 * 			
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage#getRoleNames()
 * @model
 * @generated
 */
public final class RoleNames extends AbstractEnumerator {
	/**
	 * The '<em><b>Sensor</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SENSOR_LITERAL
	 * @model name="sensor"
	 * @generated
	 * @ordered
	 */
	public static final int SENSOR = 0;

	/**
	 * The '<em><b>Message Extractor</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MESSAGE_EXTRACTOR_LITERAL
	 * @model name="messageExtractor"
	 * @generated
	 * @ordered
	 */
	public static final int MESSAGE_EXTRACTOR = 1;

	/**
	 * The '<em><b>Parser</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PARSER_LITERAL
	 * @model name="parser"
	 * @generated
	 * @ordered
	 */
	public static final int PARSER = 2;

	/**
	 * The '<em><b>Formatter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FORMATTER_LITERAL
	 * @model name="formatter"
	 * @generated
	 * @ordered
	 */
	public static final int FORMATTER = 3;

	/**
	 * The '<em><b>Message Filter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MESSAGE_FILTER_LITERAL
	 * @model name="messageFilter"
	 * @generated
	 * @ordered
	 */
	public static final int MESSAGE_FILTER = 4;

	/**
	 * The '<em><b>Cbe Filter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CBE_FILTER_LITERAL
	 * @model name="cbeFilter"
	 * @generated
	 * @ordered
	 */
	public static final int CBE_FILTER = 5;

	/**
	 * The '<em><b>Outputter</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OUTPUTTER_LITERAL
	 * @model name="outputter"
	 * @generated
	 * @ordered
	 */
	public static final int OUTPUTTER = 6;

	/**
	 * The '<em><b>Context</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONTEXT_LITERAL
	 * @model name="context"
	 * @generated
	 * @ordered
	 */
	public static final int CONTEXT = 7;

	/**
	 * The '<em><b>Undeclared</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED_LITERAL
	 * @model name="undeclared"
	 * @generated
	 * @ordered
	 */
	public static final int UNDECLARED = 8;

	/**
	 * The '<em><b>Sensor</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Sensor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SENSOR
	 * @generated
	 * @ordered
	 */
	public static final RoleNames SENSOR_LITERAL = new RoleNames(SENSOR, "sensor");

	/**
	 * The '<em><b>Message Extractor</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Message Extractor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MESSAGE_EXTRACTOR
	 * @generated
	 * @ordered
	 */
	public static final RoleNames MESSAGE_EXTRACTOR_LITERAL = new RoleNames(MESSAGE_EXTRACTOR, "messageExtractor");

	/**
	 * The '<em><b>Parser</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Parser</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PARSER
	 * @generated
	 * @ordered
	 */
	public static final RoleNames PARSER_LITERAL = new RoleNames(PARSER, "parser");

	/**
	 * The '<em><b>Formatter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Formatter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FORMATTER
	 * @generated
	 * @ordered
	 */
	public static final RoleNames FORMATTER_LITERAL = new RoleNames(FORMATTER, "formatter");

	/**
	 * The '<em><b>Message Filter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Message Filter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MESSAGE_FILTER
	 * @generated
	 * @ordered
	 */
	public static final RoleNames MESSAGE_FILTER_LITERAL = new RoleNames(MESSAGE_FILTER, "messageFilter");

	/**
	 * The '<em><b>Cbe Filter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Cbe Filter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CBE_FILTER
	 * @generated
	 * @ordered
	 */
	public static final RoleNames CBE_FILTER_LITERAL = new RoleNames(CBE_FILTER, "cbeFilter");

	/**
	 * The '<em><b>Outputter</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Outputter</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OUTPUTTER
	 * @generated
	 * @ordered
	 */
	public static final RoleNames OUTPUTTER_LITERAL = new RoleNames(OUTPUTTER, "outputter");

	/**
	 * The '<em><b>Context</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Context</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CONTEXT
	 * @generated
	 * @ordered
	 */
	public static final RoleNames CONTEXT_LITERAL = new RoleNames(CONTEXT, "context");

	/**
	 * The '<em><b>Undeclared</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Undeclared</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED
	 * @generated
	 * @ordered
	 */
	public static final RoleNames UNDECLARED_LITERAL = new RoleNames(UNDECLARED, "undeclared");

	/**
	 * An array of all the '<em><b>Role Names</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RoleNames[] VALUES_ARRAY =
		new RoleNames[] {
			SENSOR_LITERAL,
			MESSAGE_EXTRACTOR_LITERAL,
			PARSER_LITERAL,
			FORMATTER_LITERAL,
			MESSAGE_FILTER_LITERAL,
			CBE_FILTER_LITERAL,
			OUTPUTTER_LITERAL,
			CONTEXT_LITERAL,
			UNDECLARED_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Role Names</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Role Names</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RoleNames get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RoleNames result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Role Names</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RoleNames get(int value) {
		switch (value) {
			case SENSOR: return SENSOR_LITERAL;
			case MESSAGE_EXTRACTOR: return MESSAGE_EXTRACTOR_LITERAL;
			case PARSER: return PARSER_LITERAL;
			case FORMATTER: return FORMATTER_LITERAL;
			case MESSAGE_FILTER: return MESSAGE_FILTER_LITERAL;
			case CBE_FILTER: return CBE_FILTER_LITERAL;
			case OUTPUTTER: return OUTPUTTER_LITERAL;
			case CONTEXT: return CONTEXT_LITERAL;
			case UNDECLARED: return UNDECLARED_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RoleNames(int value, String name) {
		super(value, name);
	}

} //RoleNames
