/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: RangeRelationalOperatorType.java,v 1.1 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.filter;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Range Relational Operator Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 *     Relational operators that can specify a range.
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getRangeRelationalOperatorType()
 * @model
 * @generated
 */
public final class RangeRelationalOperatorType extends AbstractEnumerator {
	/**
	 * The '<em><b>Last</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LAST_LITERAL
	 * @model name="last"
	 * @generated
	 * @ordered
	 */
	public static final int LAST = 0;

	/**
	 * The '<em><b>First</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FIRST_LITERAL
	 * @model name="first"
	 * @generated
	 * @ordered
	 */
	public static final int FIRST = 1;

	/**
	 * The '<em><b>Last</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Last</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LAST
	 * @generated
	 * @ordered
	 */
	public static final RangeRelationalOperatorType LAST_LITERAL = new RangeRelationalOperatorType(LAST, "last");

	/**
	 * The '<em><b>First</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>First</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FIRST
	 * @generated
	 * @ordered
	 */
	public static final RangeRelationalOperatorType FIRST_LITERAL = new RangeRelationalOperatorType(FIRST, "first");

	/**
	 * An array of all the '<em><b>Range Relational Operator Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final RangeRelationalOperatorType[] VALUES_ARRAY =
		new RangeRelationalOperatorType[] {
			LAST_LITERAL,
			FIRST_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Range Relational Operator Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Range Relational Operator Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RangeRelationalOperatorType get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RangeRelationalOperatorType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Range Relational Operator Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static RangeRelationalOperatorType get(int value) {
		switch (value) {
			case LAST: return LAST_LITERAL;
			case FIRST: return FIRST_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private RangeRelationalOperatorType(int value, String name) {
		super(value, name);
	}

} //RangeRelationalOperatorType
