/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: OutputterPackageImpl.java,v 1.11 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

import org.eclipse.emf.ecore.xml.type.impl.XMLTypePackageImpl;

import org.eclipse.hyades.logging.adapter.model.internal.adapter.AdapterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.adapter.impl.AdapterPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.configuration.ConfigurationPackage;
import org.eclipse.hyades.logging.adapter.model.internal.configuration.impl.ConfigurationPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage;
import org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.extractor.ExtractorPackage;
import org.eclipse.hyades.logging.adapter.model.internal.extractor.impl.ExtractorPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage;

import org.eclipse.hyades.logging.adapter.model.internal.filter.impl.FilterPackageImpl;

import org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.formatter.impl.FormatterPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterFactory;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.StandardOutOutputterTypeType;

import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage;
import org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage;
import org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.unit.UnitPackage;
import org.eclipse.hyades.logging.adapter.model.internal.unit.impl.UnitPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OutputterPackageImpl extends EPackageImpl implements OutputterPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loggingAgentOutputterTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass notificationOutputterTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass outputterConfigTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass singleFileOutputterTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass standardOutOutputterTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass documentRootEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum outputterTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType outputterTypeObjectEDataType = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private OutputterPackageImpl() {
		super(eNS_URI, OutputterFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static OutputterPackage init() {
		if (isInited) return (OutputterPackage)EPackage.Registry.INSTANCE.getEPackage(OutputterPackage.eNS_URI);

		// Obtain or create and register package
		OutputterPackageImpl theOutputterPackage = (OutputterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof OutputterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new OutputterPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackageImpl.init();

		// Obtain or create and register interdependencies
		FilterPackageImpl theFilterPackage = (FilterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FilterPackage.eNS_URI) instanceof FilterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FilterPackage.eNS_URI) : FilterPackageImpl.eINSTANCE);
		ParserPackageImpl theParserPackage = (ParserPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ParserPackage.eNS_URI) instanceof ParserPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ParserPackage.eNS_URI) : ParserPackageImpl.eINSTANCE);
		AdapterPackageImpl theAdapterPackage = (AdapterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterPackage.eNS_URI) instanceof AdapterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterPackage.eNS_URI) : AdapterPackageImpl.eINSTANCE);
		ConfigurationPackageImpl theConfigurationPackage = (ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ConfigurationPackage.eNS_URI) instanceof ConfigurationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ConfigurationPackage.eNS_URI) : ConfigurationPackageImpl.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackageImpl.eINSTANCE);
		ContextPackageImpl theContextPackage = (ContextPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContextPackage.eNS_URI) instanceof ContextPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContextPackage.eNS_URI) : ContextPackageImpl.eINSTANCE);
		ExtractorPackageImpl theExtractorPackage = (ExtractorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtractorPackage.eNS_URI) instanceof ExtractorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtractorPackage.eNS_URI) : ExtractorPackageImpl.eINSTANCE);
		FormatterPackageImpl theFormatterPackage = (FormatterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FormatterPackage.eNS_URI) instanceof FormatterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FormatterPackage.eNS_URI) : FormatterPackageImpl.eINSTANCE);
		SensorPackageImpl theSensorPackage = (SensorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SensorPackage.eNS_URI) instanceof SensorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SensorPackage.eNS_URI) : SensorPackageImpl.eINSTANCE);

		// Create package meta-data objects
		theOutputterPackage.createPackageContents();
		theFilterPackage.createPackageContents();
		theParserPackage.createPackageContents();
		theAdapterPackage.createPackageContents();
		theConfigurationPackage.createPackageContents();
		theUnitPackage.createPackageContents();
		theContextPackage.createPackageContents();
		theExtractorPackage.createPackageContents();
		theFormatterPackage.createPackageContents();
		theSensorPackage.createPackageContents();

		// Initialize created meta-data
		theOutputterPackage.initializePackageContents();
		theFilterPackage.initializePackageContents();
		theParserPackage.initializePackageContents();
		theAdapterPackage.initializePackageContents();
		theConfigurationPackage.initializePackageContents();
		theUnitPackage.initializePackageContents();
		theContextPackage.initializePackageContents();
		theExtractorPackage.initializePackageContents();
		theFormatterPackage.initializePackageContents();
		theSensorPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theOutputterPackage.freeze();

		return theOutputterPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoggingAgentOutputterTypeType() {
		return loggingAgentOutputterTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoggingAgentOutputterTypeType_AgentName() {
		return (EAttribute)loggingAgentOutputterTypeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoggingAgentOutputterTypeType_WaitUntilLoggingTime() {
		return (EAttribute)loggingAgentOutputterTypeTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNotificationOutputterTypeType() {
		return notificationOutputterTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotificationOutputterTypeType_ResourceURL() {
		return (EAttribute)notificationOutputterTypeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOutputterConfigType() {
		return outputterConfigTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOutputterConfigType_SingleFileOutputterType() {
		return (EReference)outputterConfigTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOutputterConfigType_StandardOutOutputterType() {
		return (EReference)outputterConfigTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOutputterConfigType_LoggingAgentOutputterType() {
		return (EReference)outputterConfigTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOutputterConfigType_NotificationOutputterType() {
		return (EReference)outputterConfigTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOutputterConfigType_Type() {
		return (EAttribute)outputterConfigTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSingleFileOutputterTypeType() {
		return singleFileOutputterTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSingleFileOutputterTypeType_Directory() {
		return (EAttribute)singleFileOutputterTypeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSingleFileOutputterTypeType_FileName() {
		return (EAttribute)singleFileOutputterTypeTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStandardOutOutputterTypeType() {
		return standardOutOutputterTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDocumentRoot() {
		return documentRootEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDocumentRoot_Mixed() {
		return (EAttribute)documentRootEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XMLNSPrefixMap() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XSISchemaLocation() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_LoggingAgentOutputterType() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_NotificationOutputterType() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_SingleFileOutputterType() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_StandardOutOutputterType() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getOutputterType() {
		return outputterTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getOutputterTypeObject() {
		return outputterTypeObjectEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OutputterFactory getOutputterFactory() {
		return (OutputterFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		loggingAgentOutputterTypeTypeEClass = createEClass(LOGGING_AGENT_OUTPUTTER_TYPE_TYPE);
		createEAttribute(loggingAgentOutputterTypeTypeEClass, LOGGING_AGENT_OUTPUTTER_TYPE_TYPE__AGENT_NAME);
		createEAttribute(loggingAgentOutputterTypeTypeEClass, LOGGING_AGENT_OUTPUTTER_TYPE_TYPE__WAIT_UNTIL_LOGGING_TIME);

		notificationOutputterTypeTypeEClass = createEClass(NOTIFICATION_OUTPUTTER_TYPE_TYPE);
		createEAttribute(notificationOutputterTypeTypeEClass, NOTIFICATION_OUTPUTTER_TYPE_TYPE__RESOURCE_URL);

		outputterConfigTypeEClass = createEClass(OUTPUTTER_CONFIG_TYPE);
		createEReference(outputterConfigTypeEClass, OUTPUTTER_CONFIG_TYPE__SINGLE_FILE_OUTPUTTER_TYPE);
		createEReference(outputterConfigTypeEClass, OUTPUTTER_CONFIG_TYPE__STANDARD_OUT_OUTPUTTER_TYPE);
		createEReference(outputterConfigTypeEClass, OUTPUTTER_CONFIG_TYPE__LOGGING_AGENT_OUTPUTTER_TYPE);
		createEReference(outputterConfigTypeEClass, OUTPUTTER_CONFIG_TYPE__NOTIFICATION_OUTPUTTER_TYPE);
		createEAttribute(outputterConfigTypeEClass, OUTPUTTER_CONFIG_TYPE__TYPE);

		singleFileOutputterTypeTypeEClass = createEClass(SINGLE_FILE_OUTPUTTER_TYPE_TYPE);
		createEAttribute(singleFileOutputterTypeTypeEClass, SINGLE_FILE_OUTPUTTER_TYPE_TYPE__DIRECTORY);
		createEAttribute(singleFileOutputterTypeTypeEClass, SINGLE_FILE_OUTPUTTER_TYPE_TYPE__FILE_NAME);

		standardOutOutputterTypeTypeEClass = createEClass(STANDARD_OUT_OUTPUTTER_TYPE_TYPE);

		documentRootEClass = createEClass(DOCUMENT_ROOT);
		createEAttribute(documentRootEClass, DOCUMENT_ROOT__MIXED);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
		createEReference(documentRootEClass, DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE);

		// Create enums
		outputterTypeEEnum = createEEnum(OUTPUTTER_TYPE);

		// Create data types
		outputterTypeObjectEDataType = createEDataType(OUTPUTTER_TYPE_OBJECT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackageImpl theXMLTypePackage = (XMLTypePackageImpl)EPackage.Registry.INSTANCE.getEPackage(XMLTypePackage.eNS_URI);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI);

		// Add supertypes to classes
		outputterConfigTypeEClass.getESuperTypes().add(theUnitPackage.getProcessUnitType());

		// Initialize classes and features; add operations and parameters
		initEClass(loggingAgentOutputterTypeTypeEClass, LoggingAgentOutputterTypeType.class, "LoggingAgentOutputterTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLoggingAgentOutputterTypeType_AgentName(), theXMLTypePackage.getString(), "agentName", null, 1, 1, LoggingAgentOutputterTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLoggingAgentOutputterTypeType_WaitUntilLoggingTime(), theXMLTypePackage.getString(), "waitUntilLoggingTime", null, 0, 1, LoggingAgentOutputterTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(notificationOutputterTypeTypeEClass, NotificationOutputterTypeType.class, "NotificationOutputterTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNotificationOutputterTypeType_ResourceURL(), theXMLTypePackage.getString(), "resourceURL", null, 1, 1, NotificationOutputterTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(outputterConfigTypeEClass, OutputterConfigType.class, "OutputterConfigType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOutputterConfigType_SingleFileOutputterType(), this.getSingleFileOutputterTypeType(), null, "singleFileOutputterType", null, 0, 1, OutputterConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getOutputterConfigType_StandardOutOutputterType(), this.getStandardOutOutputterTypeType(), null, "standardOutOutputterType", null, 0, 1, OutputterConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getOutputterConfigType_LoggingAgentOutputterType(), this.getLoggingAgentOutputterTypeType(), null, "loggingAgentOutputterType", null, 0, 1, OutputterConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getOutputterConfigType_NotificationOutputterType(), this.getNotificationOutputterTypeType(), null, "notificationOutputterType", null, 0, 1, OutputterConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOutputterConfigType_Type(), this.getOutputterType(), "type", "StandardOutOutputter", 1, 1, OutputterConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(singleFileOutputterTypeTypeEClass, SingleFileOutputterTypeType.class, "SingleFileOutputterTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSingleFileOutputterTypeType_Directory(), theXMLTypePackage.getString(), "directory", null, 1, 1, SingleFileOutputterTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSingleFileOutputterTypeType_FileName(), theXMLTypePackage.getString(), "fileName", null, 1, 1, SingleFileOutputterTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(standardOutOutputterTypeTypeEClass, StandardOutOutputterTypeType.class, "StandardOutOutputterTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(documentRootEClass, DocumentRoot.class, "DocumentRoot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDocumentRoot_Mixed(), ecorePackage.getEFeatureMapEntry(), "mixed", null, 0, -1, null, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XMLNSPrefixMap(), ecorePackage.getEStringToStringMapEntry(), null, "xMLNSPrefixMap", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XSISchemaLocation(), ecorePackage.getEStringToStringMapEntry(), null, "xSISchemaLocation", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_LoggingAgentOutputterType(), this.getLoggingAgentOutputterTypeType(), null, "loggingAgentOutputterType", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_NotificationOutputterType(), this.getNotificationOutputterTypeType(), null, "notificationOutputterType", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_SingleFileOutputterType(), this.getSingleFileOutputterTypeType(), null, "singleFileOutputterType", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_StandardOutOutputterType(), this.getStandardOutOutputterTypeType(), null, "standardOutOutputterType", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(outputterTypeEEnum, OutputterType.class, "OutputterType");
		addEEnumLiteral(outputterTypeEEnum, OutputterType.STANDARD_OUT_OUTPUTTER_LITERAL);
		addEEnumLiteral(outputterTypeEEnum, OutputterType.SINGLE_FILE_OUTPUTTER_LITERAL);
		addEEnumLiteral(outputterTypeEEnum, OutputterType.LOGGING_AGENT_OUTPUTTER_LITERAL);
		addEEnumLiteral(outputterTypeEEnum, OutputterType.NOTIFICATION_OUTPUTTER_LITERAL);
		addEEnumLiteral(outputterTypeEEnum, OutputterType.UNDECLARED_LITERAL);

		// Initialize data types
		initEDataType(outputterTypeObjectEDataType, OutputterType.class, "OutputterTypeObject", IS_SERIALIZABLE, IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http:///org/eclipse/emf/ecore/util/ExtendedMetaData
		createExtendedMetaDataAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http:///org/eclipse/emf/ecore/util/ExtendedMetaData</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createExtendedMetaDataAnnotations() {
		String source = "http:///org/eclipse/emf/ecore/util/ExtendedMetaData";			
		addAnnotation
		  (loggingAgentOutputterTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "LoggingAgentOutputterType_._type",
			 "kind", "empty"
		   });			
		addAnnotation
		  (getLoggingAgentOutputterTypeType_AgentName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "agentName"
		   });			
		addAnnotation
		  (getLoggingAgentOutputterTypeType_WaitUntilLoggingTime(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "waitUntilLoggingTime"
		   });		
		addAnnotation
		  (notificationOutputterTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "NotificationOutputterType_._type",
			 "kind", "empty"
		   });			
		addAnnotation
		  (getNotificationOutputterTypeType_ResourceURL(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "resourceURL"
		   });			
		addAnnotation
		  (outputterConfigTypeEClass, 
		   source, 
		   new String[] {
			 "name", "OutputterConfigType",
			 "kind", "elementOnly"
		   });		
		addAnnotation
		  (getOutputterConfigType_SingleFileOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "SingleFileOutputterType",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getOutputterConfigType_StandardOutOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "StandardOutOutputterType",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getOutputterConfigType_LoggingAgentOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "LoggingAgentOutputterType",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getOutputterConfigType_NotificationOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "NotificationOutputterType",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getOutputterConfigType_Type(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "type"
		   });			
		addAnnotation
		  (outputterTypeEEnum, 
		   source, 
		   new String[] {
			 "name", "OutputterType"
		   });		
		addAnnotation
		  (outputterTypeObjectEDataType, 
		   source, 
		   new String[] {
			 "name", "OutputterType:Object",
			 "baseType", "OutputterType"
		   });		
		addAnnotation
		  (singleFileOutputterTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "SingleFileOutputterType_._type",
			 "kind", "empty"
		   });			
		addAnnotation
		  (getSingleFileOutputterTypeType_Directory(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "directory"
		   });			
		addAnnotation
		  (getSingleFileOutputterTypeType_FileName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "fileName"
		   });		
		addAnnotation
		  (standardOutOutputterTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "StandardOutOutputterType_._type",
			 "kind", "empty"
		   });		
		addAnnotation
		  (documentRootEClass, 
		   source, 
		   new String[] {
			 "name", "",
			 "kind", "mixed"
		   });		
		addAnnotation
		  (getDocumentRoot_Mixed(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "name", ":mixed"
		   });		
		addAnnotation
		  (getDocumentRoot_XMLNSPrefixMap(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xmlns:prefix"
		   });		
		addAnnotation
		  (getDocumentRoot_XSISchemaLocation(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xsi:schemaLocation"
		   });			
		addAnnotation
		  (getDocumentRoot_LoggingAgentOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "LoggingAgentOutputterType",
			 "namespace", "##targetNamespace"
		   });			
		addAnnotation
		  (getDocumentRoot_NotificationOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "NotificationOutputterType",
			 "namespace", "##targetNamespace"
		   });			
		addAnnotation
		  (getDocumentRoot_SingleFileOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "SingleFileOutputterType",
			 "namespace", "##targetNamespace"
		   });			
		addAnnotation
		  (getDocumentRoot_StandardOutOutputterType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "StandardOutOutputterType",
			 "namespace", "##targetNamespace"
		   });
	}

} //OutputterPackageImpl
