/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ParserConfigType.java,v 1.10 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Config Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * 			This is the root element discription.  All the parser
 * 			rules are hierachicaly arranged under this element.
 * 			
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getRuleElement <em>Rule Element</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDesignationToken <em>Designation Token</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getSeparatorToken <em>Separator Token</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getUniqueID <em>Unique ID</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType()
 * @model 
 * @generated
 */
public interface ParserConfigType extends EObject{
	/**
	 * Returns the value of the '<em><b>Rule Element</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule Element</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule Element</em>' containment reference list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType_RuleElement()
	 * @model type="org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType" containment="true" resolveProxies="false"
	 * @generated
	 */
	EList getRuleElement();

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType_Description()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Designation Token</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Designation Token</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Designation Token</em>' attribute.
	 * @see #setDesignationToken(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType_DesignationToken()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getDesignationToken();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDesignationToken <em>Designation Token</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Designation Token</em>' attribute.
	 * @see #getDesignationToken()
	 * @generated
	 */
	void setDesignationToken(String value);

	/**
	 * Returns the value of the '<em><b>Separator Token</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Separator Token</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Separator Token</em>' attribute.
	 * @see #setSeparatorToken(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType_SeparatorToken()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getSeparatorToken();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getSeparatorToken <em>Separator Token</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Separator Token</em>' attribute.
	 * @see #getSeparatorToken()
	 * @generated
	 */
	void setSeparatorToken(String value);

	/**
	 * Returns the value of the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unique ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unique ID</em>' attribute.
	 * @see #setUniqueID(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getParserConfigType_UniqueID()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getUniqueID();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getUniqueID <em>Unique ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unique ID</em>' attribute.
	 * @see #getUniqueID()
	 * @generated
	 */
	void setUniqueID(String value);

} // ParserConfigType
