/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: SensorConfigType.java,v 1.11 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.sensor;

import java.math.BigInteger;

import org.eclipse.hyades.logging.adapter.model.internal.unit.ProcessUnitType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Config Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 *              A sensor consists of some space
 *                 control related attributes and a single
 *                 specific sensor implementation.    A sensor is a
 *                 processing unit aka             component and has those
 *                 implied attributes as well.             Sensor
 *                 parameters are specified as sensor             property
 *                 elements called SensorProperty.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getSingleFileSensor <em>Single File Sensor</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getAdapterCBESensor <em>Adapter CBE Sensor</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getStaticParserSensor <em>Static Parser Sensor</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getConfidenceBufferSize <em>Confidence Buffer Size</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getFileFooterSize <em>File Footer Size</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getMaximumBlocking <em>Maximum Blocking</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType()
 * @model 
 * @generated
 */
public interface SensorConfigType extends ProcessUnitType{
	/**
	 * Returns the value of the '<em><b>Single File Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Single File Sensor</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Single File Sensor</em>' containment reference.
	 * @see #setSingleFileSensor(SingleFileSensorType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_SingleFileSensor()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	SingleFileSensorType getSingleFileSensor();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getSingleFileSensor <em>Single File Sensor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Single File Sensor</em>' containment reference.
	 * @see #getSingleFileSensor()
	 * @generated
	 */
	void setSingleFileSensor(SingleFileSensorType value);

	/**
	 * Returns the value of the '<em><b>Adapter CBE Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Adapter CBE Sensor</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Adapter CBE Sensor</em>' containment reference.
	 * @see #setAdapterCBESensor(AdapterCBESensorType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_AdapterCBESensor()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	AdapterCBESensorType getAdapterCBESensor();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getAdapterCBESensor <em>Adapter CBE Sensor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Adapter CBE Sensor</em>' containment reference.
	 * @see #getAdapterCBESensor()
	 * @generated
	 */
	void setAdapterCBESensor(AdapterCBESensorType value);

	/**
	 * Returns the value of the '<em><b>Static Parser Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Static Parser Sensor</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Static Parser Sensor</em>' containment reference.
	 * @see #setStaticParserSensor(StaticParserSensorType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_StaticParserSensor()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	StaticParserSensorType getStaticParserSensor();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getStaticParserSensor <em>Static Parser Sensor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Static Parser Sensor</em>' containment reference.
	 * @see #getStaticParserSensor()
	 * @generated
	 */
	void setStaticParserSensor(StaticParserSensorType value);

	/**
	 * Returns the value of the '<em><b>Confidence Buffer Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 *                             confidenceBufferSize is used to store the historic information at the
	 *                             end of a file.  Then, subsequent checks to determine if the file has been 
	 *                             appended to or replaced can use this buffer to compare where the append 
	 *                             operation started at. If no value is specified the adapter assumes 
	 *                             a confidenceBufferSize of 1024 bytes.
	 *                         
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Confidence Buffer Size</em>' attribute.
	 * @see #setConfidenceBufferSize(BigInteger)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_ConfidenceBufferSize()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.Integer"
	 * @generated
	 */
	BigInteger getConfidenceBufferSize();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getConfidenceBufferSize <em>Confidence Buffer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Confidence Buffer Size</em>' attribute.
	 * @see #getConfidenceBufferSize()
	 * @generated
	 */
	void setConfidenceBufferSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>File Footer Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 *                             fileFooterSize is used  in conjunction with the confidenceBufferSize.  This
	 *                             is the tail portion of a file which is used to store footer information and will
	 *                             not be used as part of the comparison to determine if an append has occured.
	 *                             If no value is specified the adapter assumes a fileFooterSize of 90 bytes.
	 *                         
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>File Footer Size</em>' attribute.
	 * @see #setFileFooterSize(BigInteger)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_FileFooterSize()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.Integer"
	 * @generated
	 */
	BigInteger getFileFooterSize();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getFileFooterSize <em>File Footer Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>File Footer Size</em>' attribute.
	 * @see #getFileFooterSize()
	 * @generated
	 */
	void setFileFooterSize(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Maximum Blocking</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 *                             maximumBlocking is used to determine how
	 *                             many records can be
	 *                             passed out of the sensor. For example a
	 *                             value of 5 implies that
	 *                             5 or less records can be provided in one
	 *                             call to a sensor.                       This
	 *                             is an important tuning feature because large
	 *                             blocks                       reduce context
	 *                             flow overhead, yet also often require more memory.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Maximum Blocking</em>' attribute.
	 * @see #setMaximumBlocking(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_MaximumBlocking()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getMaximumBlocking();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getMaximumBlocking <em>Maximum Blocking</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximum Blocking</em>' attribute.
	 * @see #getMaximumBlocking()
	 * @generated
	 */
	void setMaximumBlocking(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"AdapterCBESensor"</code>.
	 * The literals are from the enumeration {@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @see #isSetType()
	 * @see #unsetType()
	 * @see #setType(SensorType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorConfigType_Type()
	 * @model default="AdapterCBESensor" unique="false" unsettable="true" required="true"
	 * @generated
	 */
	SensorType getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @see #isSetType()
	 * @see #unsetType()
	 * @see #getType()
	 * @generated
	 */
	void setType(SensorType value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetType()
	 * @see #getType()
	 * @see #setType(SensorType)
	 * @generated
	 */
	void unsetType();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType <em>Type</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Type</em>' attribute is set.
	 * @see #unsetType()
	 * @see #getType()
	 * @see #setType(SensorType)
	 * @generated
	 */
	boolean isSetType();

} // SensorConfigType
