/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IStatefulSubstitutionExtension.java,v 1.4 2005/02/16 22:20:29 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.logging.adapter.parsers;


/**
 * @author smith
 *
 * This is the interface that will be used to supply external code to the parser
 * component to process all of a record or a portion of a record to generate a
 * parse value for some attribute.  That is, the interface defines an extension
 * to a substitution rule.  The implementation code can be stateful.
 * That is, the caller of the class assumes one object is used for all records.
 * 
 */
public interface IStatefulSubstitutionExtension  extends ISubstitutionExtension {


}
