/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CFGOperation.java,v 1.10 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.facades.behavioral.IMethod;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CFG Operation</b></em>'.
 * @extends IMethod
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An operation is a service that can be requested from a deployable.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getOwningClass <em>Owning Class</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGOperation()
 * @model 
 * @generated
 */
public interface CFGOperation extends CMNNamedElement, IMethod{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Owning Class</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGClass#getOperations <em>Operations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owning Class</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owning Class</em>' container reference.
	 * @see #setOwningClass(CFGClass)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGOperation_OwningClass()
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass#getOperations
	 * @model opposite="operations" required="true"
	 * @generated
	 */
	CFGClass getOwningClass();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGOperation#getOwningClass <em>Owning Class</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owning Class</em>' container reference.
	 * @see #getOwningClass()
	 * @generated
	 */
	void setOwningClass(CFGClass value);

} // CFGOperation
