/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCCollectionMode.java,v 1.21 2005/03/16 19:35:59 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TRC Collection Mode</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCCollectionMode()
 * @model
 * @generated
 */
public final class TRCCollectionMode extends AbstractEnumerator
{
	/**
	 * The '<em><b>HEAP STATISTICS ONLY</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_STATISTICS_ONLY_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_STATISTICS_ONLY = 0;

	/**
	 * The '<em><b>HEAP FULL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_FULL_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_FULL = 1;

	/**
	 * The '<em><b>HEAP AND EXECUTION FULL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_AND_EXECUTION_FULL_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_AND_EXECUTION_FULL = 2;

	/**
	 * The '<em><b>HEAP AND EXECUTION STATISTICS ONLY</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_AND_EXECUTION_STATISTICS_ONLY_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_AND_EXECUTION_STATISTICS_ONLY = 3;

	/**
	 * The '<em><b>EXECUTION STATISTICS ONLY</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_STATISTICS_ONLY_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int EXECUTION_STATISTICS_ONLY = 4;

	/**
	 * The '<em><b>EXECUTION NO INSTANCES</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_NO_INSTANCES_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int EXECUTION_NO_INSTANCES = 5;

	/**
	 * The '<em><b>EXECUTION FULL</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_FULL_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int EXECUTION_FULL = 6;

	/**
	 * The '<em><b>HEAP FULL AND EXECUTION STATISTICS ONLY</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY = 7;

	/**
	 * The '<em><b>HEAP STATISTICS ONLY</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP STATISTICS ONLY</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_STATISTICS_ONLY
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode HEAP_STATISTICS_ONLY_LITERAL = new TRCCollectionMode(HEAP_STATISTICS_ONLY, "HEAP_STATISTICS_ONLY");

	/**
	 * The '<em><b>HEAP FULL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP FULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_FULL
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode HEAP_FULL_LITERAL = new TRCCollectionMode(HEAP_FULL, "HEAP_FULL");

	/**
	 * The '<em><b>HEAP AND EXECUTION FULL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP AND EXECUTION FULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_AND_EXECUTION_FULL
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode HEAP_AND_EXECUTION_FULL_LITERAL = new TRCCollectionMode(HEAP_AND_EXECUTION_FULL, "HEAP_AND_EXECUTION_FULL");

	/**
	 * The '<em><b>HEAP AND EXECUTION STATISTICS ONLY</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP AND EXECUTION STATISTICS ONLY</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_AND_EXECUTION_STATISTICS_ONLY
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode HEAP_AND_EXECUTION_STATISTICS_ONLY_LITERAL = new TRCCollectionMode(HEAP_AND_EXECUTION_STATISTICS_ONLY, "HEAP_AND_EXECUTION_STATISTICS_ONLY");

	/**
	 * The '<em><b>EXECUTION STATISTICS ONLY</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EXECUTION STATISTICS ONLY</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_STATISTICS_ONLY
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode EXECUTION_STATISTICS_ONLY_LITERAL = new TRCCollectionMode(EXECUTION_STATISTICS_ONLY, "EXECUTION_STATISTICS_ONLY");

	/**
	 * The '<em><b>EXECUTION NO INSTANCES</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EXECUTION NO INSTANCES</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_NO_INSTANCES
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode EXECUTION_NO_INSTANCES_LITERAL = new TRCCollectionMode(EXECUTION_NO_INSTANCES, "EXECUTION_NO_INSTANCES");

	/**
	 * The '<em><b>EXECUTION FULL</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>EXECUTION FULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EXECUTION_FULL
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode EXECUTION_FULL_LITERAL = new TRCCollectionMode(EXECUTION_FULL, "EXECUTION_FULL");

	/**
	 * The '<em><b>HEAP FULL AND EXECUTION STATISTICS ONLY</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>HEAP FULL AND EXECUTION STATISTICS ONLY</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY
	 * @generated
	 * @ordered
	 */
	public static final TRCCollectionMode HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY_LITERAL = new TRCCollectionMode(HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY, "HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY");

	/**
	 * An array of all the '<em><b>TRC Collection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TRCCollectionMode[] VALUES_ARRAY =
		new TRCCollectionMode[] {
			HEAP_STATISTICS_ONLY_LITERAL,
			HEAP_FULL_LITERAL,
			HEAP_AND_EXECUTION_FULL_LITERAL,
			HEAP_AND_EXECUTION_STATISTICS_ONLY_LITERAL,
			EXECUTION_STATISTICS_ONLY_LITERAL,
			EXECUTION_NO_INSTANCES_LITERAL,
			EXECUTION_FULL_LITERAL,
			HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>TRC Collection Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TRC Collection Mode</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCCollectionMode get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TRCCollectionMode result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TRC Collection Mode</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCCollectionMode get(int value) {
		switch (value) {
			case HEAP_STATISTICS_ONLY: return HEAP_STATISTICS_ONLY_LITERAL;
			case HEAP_FULL: return HEAP_FULL_LITERAL;
			case HEAP_AND_EXECUTION_FULL: return HEAP_AND_EXECUTION_FULL_LITERAL;
			case HEAP_AND_EXECUTION_STATISTICS_ONLY: return HEAP_AND_EXECUTION_STATISTICS_ONLY_LITERAL;
			case EXECUTION_STATISTICS_ONLY: return EXECUTION_STATISTICS_ONLY_LITERAL;
			case EXECUTION_NO_INSTANCES: return EXECUTION_NO_INSTANCES_LITERAL;
			case EXECUTION_FULL: return EXECUTION_FULL_LITERAL;
			case HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY: return HEAP_FULL_AND_EXECUTION_STATISTICS_ONLY_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TRCCollectionMode(int value, String name) {
		super(value, name);
	}

} //TRCCollectionMode
