/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CorrelationContainerImpl.java,v 1.17 2005/03/16 19:35:58 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.models.hierarchy.CorrelationContainer;
import org.eclipse.hyades.models.hierarchy.CorrelationContainerProxy;
import org.eclipse.hyades.models.hierarchy.HierarchyPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Correlation Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.impl.CorrelationContainerImpl#getCorrelations <em>Correlations</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.impl.CorrelationContainerImpl#getCorrelationContainerProxy <em>Correlation Container Proxy</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CorrelationContainerImpl extends EObjectImpl  implements CorrelationContainer {
	/**
	 * The cached value of the '{@link #getCorrelations() <em>Correlations</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCorrelations()
	 * @generated
	 * @ordered
	 */
	protected EMap correlations = null;

	/**
	 * The cached value of the '{@link #getCorrelationContainerProxy() <em>Correlation Container Proxy</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCorrelationContainerProxy()
	 * @generated
	 * @ordered
	 */
	protected CorrelationContainerProxy correlationContainerProxy = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CorrelationContainerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return HierarchyPackage.eINSTANCE.getCorrelationContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap getCorrelations() {
		if (correlations == null) {
			correlations = new EcoreEMap(HierarchyPackage.eINSTANCE.getCorrelationEntry(), CorrelationEntryImpl.class, this, HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS);
		}
		return correlations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CorrelationContainerProxy getCorrelationContainerProxy() {
		if (correlationContainerProxy != null && correlationContainerProxy.eIsProxy()) {
			CorrelationContainerProxy oldCorrelationContainerProxy = correlationContainerProxy;
			correlationContainerProxy = (CorrelationContainerProxy)eResolveProxy((InternalEObject)correlationContainerProxy);
			if (correlationContainerProxy != oldCorrelationContainerProxy) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, oldCorrelationContainerProxy, correlationContainerProxy));
			}
		}
		return correlationContainerProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CorrelationContainerProxy basicGetCorrelationContainerProxy() {
		return correlationContainerProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCorrelationContainerProxy(CorrelationContainerProxy newCorrelationContainerProxy, NotificationChain msgs) {
		CorrelationContainerProxy oldCorrelationContainerProxy = correlationContainerProxy;
		correlationContainerProxy = newCorrelationContainerProxy;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, oldCorrelationContainerProxy, newCorrelationContainerProxy);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCorrelationContainerProxy(CorrelationContainerProxy newCorrelationContainerProxy) {
		if (newCorrelationContainerProxy != correlationContainerProxy) {
			NotificationChain msgs = null;
			if (correlationContainerProxy != null)
				msgs = ((InternalEObject)correlationContainerProxy).eInverseRemove(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
			if (newCorrelationContainerProxy != null)
				msgs = ((InternalEObject)newCorrelationContainerProxy).eInverseAdd(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
			msgs = basicSetCorrelationContainerProxy(newCorrelationContainerProxy, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, newCorrelationContainerProxy, newCorrelationContainerProxy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
					return ((InternalEList)getCorrelations()).basicAdd(otherEnd, msgs);
				case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
					if (correlationContainerProxy != null)
						msgs = ((InternalEObject)correlationContainerProxy).eInverseRemove(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
					return basicSetCorrelationContainerProxy((CorrelationContainerProxy)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
					return ((InternalEList)getCorrelations()).basicRemove(otherEnd, msgs);
				case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
					return basicSetCorrelationContainerProxy(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				return getCorrelations();
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				if (resolve) return getCorrelationContainerProxy();
				return basicGetCorrelationContainerProxy();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				getCorrelations().clear();
				getCorrelations().addAll((Collection)newValue);
				return;
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				setCorrelationContainerProxy((CorrelationContainerProxy)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				getCorrelations().clear();
				return;
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				setCorrelationContainerProxy((CorrelationContainerProxy)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				return correlations != null && !correlations.isEmpty();
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				return correlationContainerProxy != null;
		}
		return eDynamicIsSet(eFeature);
	}

} //CorrelationContainerImpl
