/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: NamedElement.java,v 1.3 2005/02/16 22:21:48 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.test.manual.runner.model;



/**
 * @author marcelop
 * @since 1.0.2
 */
public abstract class NamedElement
{
	private String id;
	private String name;
	private String description;
	private int iteration = 1;
	
	private int executionId;
	
	public void dispose()
	{
	}
	
	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public String getDescription()
	{
		return description;
	}

	public void setDescription(String description)
	{
		this.description = description;
	}
	
	public int getIteration()
	{
		return iteration;
	}

	public void setIteration(int iteration)
	{
		this.iteration = iteration;
	}
	
	public void setExecutionId(int executionId)
	{
		this.executionId = executionId;
	}
	
	public int getExecutionId()
	{
		return executionId;
	}
	
	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return ((getName()!=null)?getName():"");
	}
}
