/**********************************************************************
 * Copyright (c) 2005 Hyades project.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.trace.ui.filters.internal.dialogs;

import org.eclipse.hyades.trace.ui.filters.FiltersStandardTabUI;
import org.eclipse.hyades.trace.ui.filters.internal.util.FilterInformationManager;
import org.eclipse.hyades.trace.ui.filters.internal.util.FilterQueries;
import org.eclipse.hyades.trace.ui.internal.filters.FilterTypesManager;
import org.eclipse.hyades.trace.ui.internal.filters.IFilterType;

public class FilterUIUtil {
	public static boolean ENABLE_NEW_FILTERING = true;
	public static boolean ENABLE_NEW_FILTERING_FOR_SQL = true;	

	public static FiltersEditDialog getFiltersEditDialog(FilterInformationManager fi)
	{
		return new FiltersEditDialog(fi);
	}

	public static FiltersDialog getFiltersDialog(FilterQueries fq, FilterInformationManager fi, int openTabIndex, int advancedTabSelectionIndex) {
		FiltersDialog dialog = new FiltersDialog(fq, fi, openTabIndex, advancedTabSelectionIndex);
		
		IFilterType ft = FilterTypesManager.instance().getFilterType(fq.type());
		FiltersStandardTabUI standardTabUI = ft.standardTabUI();
		
		FiltersAdvancedUI advancedTabUI = null;
		if (ft.advancedTabAttributeSet() != null)
			advancedTabUI = new FiltersAdvancedUI(ft.advancedTabAttributeSet());
		
		if (standardTabUI != null)
			standardTabUI.initializeDialog(dialog);
		
		if (advancedTabUI != null)
			advancedTabUI.initializeDialog(dialog);
		
		dialog.setTabUIs(standardTabUI, advancedTabUI);
		
		return dialog;
	}	
	
	public static FiltersDialog getFiltersDialog(FilterQueries fq, FilterInformationManager fi, int openTabIndex) {
		return getFiltersDialog(fq, fi, openTabIndex, -1);
	}
	
	public static FilterTypeDialog getFiltersTypeDialog(FilterInformationManager fi)
	{
		return new FilterTypeDialog(fi);
	}
}
