/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: NewNodeWizard.java,v 1.6 2005/02/16 22:24:02 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.trace.ui.internal.wizard;

import java.util.*;

import org.eclipse.hyades.models.hierarchy.*;
import org.eclipse.hyades.trace.ui.*;
import org.eclipse.hyades.trace.internal.ui.*;
import org.eclipse.hyades.ui.internal.navigator.INavigator;
import org.eclipse.jface.wizard.*;
import org.eclipse.jface.viewers.*;
import org.eclipse.ui.*;

public class NewNodeWizard extends Wizard implements INewWizard
{
  protected NewNodeWizardPage fPage;
  protected TRCMonitor        fMonitor;
  protected INavigator fViewer;

  public NewNodeWizard()
  {
	setNeedsProgressMonitor(true);
  }  
  public void addPages()
  {
	setWindowTitle(UIPlugin.getResourceString("NEW_NODE_TITLE"));
	fPage = new NewNodeWizardPage("NewNodePage", fMonitor, fViewer);
	addPage(fPage);
  }        

/**
 * Insert the method's description here.
 * Creation date: (8/7/2001 8:33:49 PM)
 * @return com.ibm.etools.pd.core.PDProjectExplorer
 */
public INavigator getViewer() {
	return fViewer;
}
  public void init(IWorkbench workbench, IStructuredSelection selection)
  {
	if (selection instanceof IStructuredSelection)
	{
	  Iterator enum = ((IStructuredSelection) selection).iterator();
	  if (enum.hasNext())
	  {
		Object obj = enum.next();
		if (obj instanceof TRCMonitor)
		  fMonitor = (TRCMonitor) obj;
	  }
	}
	
	setDefaultPageImageDescriptor(UIPlugin.getImageDescriptor(PDPluginImages.IMG_UI_WZ_NEWNODE));
  }  
  public boolean performFinish()
  {
	if( fPage.finish() )
	{
	  fViewer.getViewer().refresh(fMonitor);		
	  fViewer.getViewer().setSelection(new StructuredSelection(fPage.getNode()));		  
	 
	  return true;
	  		
	}

	return false;
  }  
  public void setViewer(INavigator viewer)
  {
	fViewer = viewer;
  }  
}
