package org.eclipse.hyades.ui.sample.svg.generator;
/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IUserPreferencesConstants.java,v 1.4 2005/02/16 22:24:05 qiyanli Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

/**
 * <code>IUserPreferencesConstants</code> interface defines the constants used
 * by classes implementing user preferences.
 * 
 * @version 1.3
 */
public interface IUserPreferencesConstants {
	/*
	 * Palette internal identifiers (used to avoid translation issues)
	 */
	String SEASIDE= "ZZ1";
	String SUMMER= 	"ZZ2";
	String EARTH= 	"ZZ3";
	String SPRING= 	"ZZ4";
	String HARVEST=	"ZZ5";
	String PASTEL= 	"ZZ6";	
	
	/*
	 * User preference page constants. Note to users: do not use 
	 * names beginning with "prefs_" for custom preference pages.
	 */	
	String PREFS=						"prefs_"; 
	String PREFS_WIDTH=					"430";	
	String NS_PREFS_WIDTH=				"360";	
	String BAR_PREFS= 					"prefs_bar.htm";	
	String BAR_PREFS_HEIGHT=			"435";	
	String NS_BAR_PREFS_HEIGHT=			"445";	
	String STACKBAR_PREFS= 				"prefs_stackedbar.htm";
	String STACKBAR_PREFS_HEIGHT=		"435";		
	String NS_STACKBAR_PREFS_HEIGHT=	"445";	
	String GROUPBAR_PREFS= 				"prefs_groupbar.htm";
	String GROUPBAR_PREFS_HEIGHT=		"435";		
	String NS_GROUPBAR_PREFS_HEIGHT=	"445";	
	String LINE_PREFS= 					"prefs_line.htm";
	String LINE_PREFS_HEIGHT=			"495";		
	String NS_LINE_PREFS_HEIGHT=		"505";	
	String AREA_PREFS= 					"prefs_area.htm";
	String AREA_PREFS_HEIGHT=			"495";		
	String NS_AREA_PREFS_HEIGHT=		"505";	
	String SCATTER_PREFS= 				"prefs_scatter.htm";
	String SCATTER_PREFS_HEIGHT=		"435";		
	String NS_SCATTER_PREFS_HEIGHT=		"505";	
	String PIE_PREFS= 					"prefs_pie.htm";
	String PIE_PREFS_HEIGHT=			"460";	
	String NS_PIE_PREFS_HEIGHT=			"465";	
	String METER_PREFS= 				"prefs_meter.htm";
	String METER_PREFS_HEIGHT=			"350";
	String NS_METER_PREFS_HEIGHT=		"305";
	String NS_PREFS=					"indexs.html";	

}
